﻿var tableData = "";
(function () {
    var overrideContext = {};
    overrideContext.ListTemplateType = 109;
    overrideContext.Templates = {};
    overrideContext.Templates.Item = customItem;
    overrideContext.Templates.Header = "<div id='customImageGalleryContainer'></div>";
    overrideContext.Templates.Footer = customFooter;
    SPClientTemplates.TemplateManager.RegisterTemplateOverrides(overrideContext);
})();

// List Item Custom Render
function customItem(ctx) {
    //Grid contains 4
    if (ctx.CurrentItemIdx % 4 == 0) {
        //start new row
        tableData += "<div style='clear:both'></div>"
    }

    tableData += "<div style='margin:5px;border:1px solid #666;float:left;" +
    "width:100px;height:100px' onmouseover=\"" +
    "ShowCallout(this, " + ctx.CurrentItem.ID + ",'" + ctx.CurrentItem.Title + "','" + ctx.CurrentItem.Description + "','" +
    ctx.CurrentItem.FileDirRef + "','" + ctx.CurrentItem.FileLeafRef
    + "');\"><img src='" + ctx.CurrentItem.FileRef +
    "' width='100' height='100' /></div>";

    return "";
}

// Custom Footer Method 
function customFooter(ctx) {
    // Append Dynamic generated data to container DIV
    $("#customImageGalleryContainer").html(tableData);
    return "";
}

// Show Callouts
function ShowCallout(sender, itemId, title, brief, directory, filename) {
    //Close fists all callouts if opened
    CalloutManager.closeAll();
    var fname = filename.replace(".", "_");
    var thumbnail = directory + "/_t/" + fname + ".jpg";
    var medium = directory + "/_w/" + fname + ".jpg";
    var full = directory + "/" + filename;
    var calloutContent = "<img src='" + medium + "' width='50%' height='50%' /><br/>" +
    brief + "<br /><br />" +
    "<a href='" + thumbnail + "' target='_blank'>Thumbnail</a>&nbsp;&nbsp;|&nbsp;&nbsp;" +
    "<a href='" + medium + "' target='_blank'>Web Size</a>&nbsp;&nbsp;|&nbsp;&nbsp;" +
    "<a href='" + full + "' target='_blank'>Original Size</a>";

    var calloutRef = CalloutManager.createNewIfNecessary({
        ID: 'call_' + itemId, launchPoint: sender,
        beakOrientation: 'leftRight', content: calloutContent, contentWidth: 610,
        title: "<a href='" + directory + "/Forms/DispForm.aspx?ID=" +
        itemId + "'>" + title + "</a>"
    });

    calloutRef.open();
}